	.module playmp3.c
	.area text(rom, con, rel)
	.dbfile C:\proj\src\ethernut\nut\app\playmp3\playmp3.c
	.dbfunc e main _main fI
;           baud -> y+2
	.even
_main::
	sbiw R28,6
	.dbline -1
	.dbline 82
; /*
;  * Copyright (C) 2003 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  */
; 
; /*!
;  * $Log$
;  */
; 
; #include <dev/vs1001k.h>
; #include <dev/debug.h>
; #include <dev/urom.h>
; 
; #include <sys/version.h>
; #include <sys/heap.h>
; #include <sys/event.h>
; #include <sys/timer.h>
; #include <sys/thread.h>
; #include <sys/bankmem.h>
; 
; #include <stdlib.h>
; #include <string.h>
; #include <stdio.h>
; #include <io.h>
; #include <fcntl.h>
; #include <errno.h>
; 
; static int PlayMp3File(char *path);
; 
; /*!
;  * \example playmp3/playmp3.c
;  *
;  * To run this example code, you need to attach the Medianut Board to the
;  * Ethernut or use a similar hardware design based on the VS1001K MP3 decoder.
;  *
;  * This sample application plays MP3 files from the UROM filesystem. It 
;  * demonstrates how to use the global segmented buffer and the MP3 decoder 
;  * driver and can provide a basis for talking equipment, alarm sound output 
;  * etc.
;  *
;  * The UROM filesystem is located in the CPU's flash ROM. No external file
;  * storage device is required. Use the crurom utility to create a C source 
;  * file named urom.c from the MP3 files located in subdirectory sounds. 
;  * Here's how to call crurom:
;  * 
;  * crurom -r -ourom.c sounds
;  *
;  * The created file will then be compiled and linked to the application 
;  * code.
;  *
;  * UART0 is used for debug output.
;  */
; int main(void)
; {
	.dbline 84
;     /* Baudrate for debug output. */
;     u_long baud = 115200;
	ldi R20,0
	ldi R21,194
	ldi R22,1
	ldi R23,0
	movw R30,R28
	std z+2,R20
	std z+3,R21
	std z+4,R22
	std z+5,R23
	.dbline 89
; 
;     /*
;      * Register our devices.
;      */
;     NutRegisterDevice(&devUrom, 0, 0);
	clr R2
	std y+0,R2
	clr R18
	clr R19
	ldi R16,<_devUrom
	ldi R17,>_devUrom
	xcall _NutRegisterDevice
	.dbline 90
;     NutRegisterDevice(&devDebug0, 0, 0);
	clr R2
	std y+0,R2
	clr R18
	clr R19
	ldi R16,<_devDebug0
	ldi R17,>_devDebug0
	xcall _NutRegisterDevice
	.dbline 95
; 
;     /*
;      * Assign stdout to the debug device.
;      */
;     freopen("uart0", "w", stdout);
	lds R2,___iob+2
	lds R3,___iob+2+1
	std y+1,R3
	std y+0,R2
	ldi R18,<L3
	ldi R19,>L3
	ldi R16,<L2
	ldi R17,>L2
	xcall _freopen
	.dbline 96
;     _ioctl(_fileno(stdout), UART_SETSPEED, &baud);
	lds R16,___iob+2
	lds R17,___iob+2+1
	xcall __fileno
	movw R24,R28
	adiw R24,2
	std y+1,R25
	std y+0,R24
	ldi R18,257
	ldi R19,1
	xcall __ioctl
	.dbline 101
; 
;     /*
;      * Print a banner.
;      */
;     printf("\n\nPlay MP3 files on Nut/OS %s\n", NutVersionString());
	xcall _NutVersionString
	movw R18,R16
	ldi R16,<L6
	ldi R17,>L6
	xcall _printf_M
	.dbline 107
; 
;     /*
;      * Initialize the MP3 buffer. The NutSegBuf routines provide a global
;      * system buffer, which works with banked and non-banked systems.
;      */
;     if (NutSegBufInit(8192) == 0) {
	ldi R16,8192
	ldi R17,32
	xcall _NutSegBufInit
	cpi R16,0
	cpc R16,R17
	brne L7
X0:
	.dbline 107
	.dbline 108
;         puts("NutSegBufInit: Fatal error");
	ldi R16,<L9
	ldi R17,>L9
	xcall _puts_M
	.dbline 109
;     }
L7:
	.dbline 114
	xcall _VsPlayerInit
	cpi R16,0
	cpc R16,R17
	brne L12
X1:
	clr R16
	clr R17
	xcall _VsPlayerReset
	cpi R16,0
	cpc R16,R17
	breq L10
X2:
L12:
	.dbline 114
; 
;     /* 
;      * Initialize the MP3 decoder hardware.
;      */
;     if (VsPlayerInit() || VsPlayerReset(0)) {
	.dbline 115
;         puts("VsPlayer: Fatal error");
	ldi R16,<L13
	ldi R17,>L13
	xcall _puts_M
	.dbline 116
;     }
L10:
	.dbline 123
L14:
	.dbline 123
	.dbline 124
	ldi R18,254
	clr R16
	xcall _VsSetVolume
	.dbline 125
	ldi R16,<L18
	ldi R17,>L18
	xcall _PlayMp3File
	.dbline 126
	ldi R16,232
	ldi R17,3
	ldi R18,0
	ldi R19,0
	xcall _NutSleep
	.dbline 128
	clr R18
	clr R16
	xcall _VsSetVolume
	.dbline 129
	ldi R16,<L19
	ldi R17,>L19
	xcall _PlayMp3File
	.dbline 130
	ldi R16,232
	ldi R17,3
	ldi R18,0
	ldi R19,0
	xcall _NutSleep
	.dbline 132
	clr R18
	ldi R16,254
	xcall _VsSetVolume
	.dbline 133
	ldi R16,<L20
	ldi R17,>L20
	xcall _PlayMp3File
	.dbline 134
	ldi R16,232
	ldi R17,3
	ldi R18,0
	ldi R19,0
	xcall _NutSleep
	.dbline 136
	clr R18
	clr R16
	xcall _VsSetVolume
	.dbline 137
	ldi R16,<L21
	ldi R17,>L21
	xcall _PlayMp3File
	.dbline 138
	ldi R16,232
	ldi R17,3
	ldi R18,0
	ldi R19,0
	xcall _NutSleep
	.dbline 139
	.dbline 123
	.dbline 123
	xjmp L14
X3:
	.dbline -2
L1:
	adiw R28,6
	.dbline 0 ; func end
	ret
	.dbsym l baud 2 l
	.dbend
	.dbfunc s PlayMp3File _PlayMp3File fI
;             fd -> y+4
;            got -> R14,R15
;         mp3buf -> R10,R11
;            ief -> R12
;         rbytes -> y+2
;           path -> R10,R11
	.even
_PlayMp3File:
	xcall push_gset5
	movw R10,R16
	sbiw R28,6
	.dbline -1
	.dbline 151
; 
;     /*
;      * Play the MP3 files in an endless loop. For each file set the volume 
;      * of the left and right channel, call the local routine PlayMp3File() 
;      * and sleep one second before playing the next sound file.
;      */
;     for (;;) {
;         VsSetVolume(0, 254);
;         PlayMp3File("UROM:sound1a.mp3");
;         NutSleep(1000);
; 
;         VsSetVolume(0, 0);
;         PlayMp3File("UROM:sound2a.mp3");
;         NutSleep(1000);
; 
;         VsSetVolume(254, 0);
;         PlayMp3File("UROM:sound3a.mp3");
;         NutSleep(1000);
; 
;         VsSetVolume(0, 0);
;         PlayMp3File("UROM:sound4a.mp3");
;         NutSleep(1000);
;     }
; }
; 
; 
; /*
;  * Play MP3 file from local file system.
;  *
;  * \param path Pathname of the MP3 file to play.
;  *
;  * \return 0 on success, -1 if opening the file failed.
;  */
; static int PlayMp3File(char *path)
; {
	.dbline 161
;     int fd;
;     size_t rbytes;
;     u_char *mp3buf;
;     int got;
;     u_char ief;
; 
;     /*
;      * Open the MP3 file.
;      */
;     printf("Play %s: ", path);
	movw R18,R10
	ldi R16,<L23
	ldi R17,>L23
	xcall _printf_M
	.dbline 162
;     if((fd = _open(path, _O_RDONLY | _O_BINARY)) == -1) {
	ldi R18,32768
	ldi R19,128
	movw R16,R10
	xcall __open
	movw R2,R16
	std y+5,R3
	std y+4,R2
	cpi R16,255
	ldi R30,255
	cpc R17,R30
	brne L24
	.dbline 162
	.dbline 163
;         printf("Error %d\n", errno);
	lds R18,_errno
	lds R19,_errno+1
	ldi R16,<L26
	ldi R17,>L26
	xcall _printf_M
	.dbline 164
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L22
L24:
	.dbline 166
;     }
;     puts("OK");
	ldi R16,<L27
	ldi R17,>L27
	xcall _puts_M
	.dbline 171
; 
;     /* 
;      * Reset decoder buffer.
;      */
;     printf("[B.RST]");
	ldi R16,<L28
	ldi R17,>L28
	xcall _printf_M
	.dbline 172
;     ief = VsPlayerInterrupts(0);
	clr R16
	xcall _VsPlayerInterrupts
	mov R12,R16
	.dbline 173
;     NutSegBufReset();
	xcall _NutSegBufReset
	.dbline 174
;     VsPlayerInterrupts(ief);
	mov R16,R12
	xcall _VsPlayerInterrupts
	.dbline 176
L29:
	.dbline 176
; 
;     for(;;) {
	.dbline 180
;         /*
;          * Query number of byte available in MP3 buffer.
;          */
;         ief = VsPlayerInterrupts(0);
	clr R16
	xcall _VsPlayerInterrupts
	mov R12,R16
	.dbline 181
;         mp3buf = NutSegBufWriteRequest(&rbytes);
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _NutSegBufWriteRequest
	movw R10,R16
	.dbline 182
;         VsPlayerInterrupts(ief);
	mov R16,R12
	xcall _VsPlayerInterrupts
	.dbline 187
; 
;         /* 
;          * Read data directly into the MP3 buffer. 
;          */
;         if(rbytes) {
	ldd R2,y+2
	ldd R3,y+3
	tst R2
	brne X4
	tst R3
	breq L33
X4:
	.dbline 187
	.dbline 188
;             printf("[B.RD%d]", rbytes);
	ldd R18,y+2
	ldd R19,y+3
	ldi R16,<L35
	ldi R17,>L35
	xcall _printf_M
	.dbline 189
;             if ((got = _read(fd, mp3buf, rbytes)) > 0) {
	ldd R2,y+2
	ldd R3,y+3
	std y+1,R3
	std y+0,R2
	movw R18,R10
	ldd R16,y+4
	ldd R17,y+5
	xcall __read
	movw R14,R16
	clr R2
	clr R3
	cp R2,R14
	cpc R3,R15
	brge L36
	.dbline 189
	.dbline 190
;                 printf("[B.CMT%d]", got);
	movw R18,R14
	ldi R16,<L38
	ldi R17,>L38
	xcall _printf_M
	.dbline 191
;                 ief = VsPlayerInterrupts(0);
	clr R16
	xcall _VsPlayerInterrupts
	mov R12,R16
	.dbline 192
;                 mp3buf = NutSegBufWriteCommit(got);
	movw R16,R14
	xcall _NutSegBufWriteCommit
	movw R10,R16
	.dbline 193
;                 VsPlayerInterrupts(ief);
	mov R16,R12
	xcall _VsPlayerInterrupts
	.dbline 194
;             }
	xjmp L37
L36:
	.dbline 195
;             else {
	.dbline 196
;                 printf("[EOF]");
	ldi R16,<L39
	ldi R17,>L39
	xcall _printf_M
	.dbline 197
;                 break;
	xjmp L31
L37:
	.dbline 199
;             }
;         }
L33:
	.dbline 204
; 
;         /*
;          * If the player is not running, kick it.
;          */
;         if (VsGetStatus() != VS_STATUS_RUNNING) {
	xcall _VsGetStatus
	cpi R16,1
	breq L40
	.dbline 204
	.dbline 205
;             printf("[P.KICK]");
	ldi R16,<L42
	ldi R17,>L42
	xcall _printf_M
	.dbline 206
;             VsPlayerKick();
	xcall _VsPlayerKick
	.dbline 207
;         }
L40:
	.dbline 212
; 
;         /*
;          * Allow background threads to take over.
;          */
;         NutThreadYield();
	xcall _NutThreadYield
	.dbline 213
;     }
	.dbline 176
	.dbline 176
	xjmp L29
L31:
	.dbline 215
; 
;     _close(fd);
	ldd R16,y+4
	ldd R17,y+5
	xcall __close
	.dbline 220
; 
;     /* 
;      * Flush decoder and wait until finished. 
;      */
;     printf("[P.FLUSH]");
	ldi R16,<L43
	ldi R17,>L43
	xcall _printf_M
	.dbline 221
;     VsPlayerFlush();
	xcall _VsPlayerFlush
	xjmp L45
L44:
	.dbline 222
	.dbline 223
	ldi R16,63
	ldi R17,0
	ldi R18,0
	ldi R19,0
	xcall _NutSleep
	.dbline 224
L45:
	.dbline 222
;     while (VsGetStatus() == VS_STATUS_RUNNING) {
	xcall _VsGetStatus
	cpi R16,1
	breq L44
	.dbline 229
;         NutSleep(63);
;     }
; 
;     /*
;      * Reset the decoder. 
;      */
;     printf("[P.RST]");
	ldi R16,<L47
	ldi R17,>L47
	xcall _printf_M
	.dbline 230
;     VsPlayerReset(0);
	clr R16
	clr R17
	xcall _VsPlayerReset
	.dbline 232
; 
;     printf("\nDone, %u bytes free\n", NutHeapAvailable());
	xcall _NutHeapAvailable
	movw R18,R16
	ldi R16,<L48
	ldi R17,>L48
	xcall _printf_M
	.dbline 233
;     return 0;
	clr R16
	clr R17
	.dbline -2
L22:
	adiw R28,6
	xcall pop_gset5
	.dbline 0 ; func end
	ret
	.dbsym l fd 4 I
	.dbsym r got 14 I
	.dbsym r mp3buf 10 pc
	.dbsym r ief 12 c
	.dbsym l rbytes 2 i
	.dbsym r path 10 pc
	.dbend
	.area data(ram, con, rel)
	.dbfile C:\proj\src\ethernut\nut\app\playmp3\playmp3.c
L48:
	.blkb 22
	.area idata
	.byte 10,'D,'o,'n,'e,44,32,37,'u,32,'b,'y,'t,'e,'s,32
	.byte 'f,'r,'e,'e,10,0
	.area data(ram, con, rel)
	.dbfile C:\proj\src\ethernut\nut\app\playmp3\playmp3.c
L47:
	.blkb 8
	.area idata
	.byte 91,'P,46,'R,'S,'T,93,0
	.area data(ram, con, rel)
	.dbfile C:\proj\src\ethernut\nut\app\playmp3\playmp3.c
L43:
	.blkb 10
	.area idata
	.byte 91,'P,46,'F,'L,'U,'S,'H,93,0
	.area data(ram, con, rel)
	.dbfile C:\proj\src\ethernut\nut\app\playmp3\playmp3.c
L42:
	.blkb 9
	.area idata
	.byte 91,'P,46,'K,'I,'C,'K,93,0
	.area data(ram, con, rel)
	.dbfile C:\proj\src\ethernut\nut\app\playmp3\playmp3.c
L39:
	.blkb 6
	.area idata
	.byte 91,'E,'O,'F,93,0
	.area data(ram, con, rel)
	.dbfile C:\proj\src\ethernut\nut\app\playmp3\playmp3.c
L38:
	.blkb 10
	.area idata
	.byte 91,'B,46,'C,'M,'T,37,'d,93,0
	.area data(ram, con, rel)
	.dbfile C:\proj\src\ethernut\nut\app\playmp3\playmp3.c
L35:
	.blkb 9
	.area idata
	.byte 91,'B,46,'R,'D,37,'d,93,0
	.area data(ram, con, rel)
	.dbfile C:\proj\src\ethernut\nut\app\playmp3\playmp3.c
L28:
	.blkb 8
	.area idata
	.byte 91,'B,46,'R,'S,'T,93,0
	.area data(ram, con, rel)
	.dbfile C:\proj\src\ethernut\nut\app\playmp3\playmp3.c
L27:
	.blkb 3
	.area idata
	.byte 'O,'K,0
	.area data(ram, con, rel)
	.dbfile C:\proj\src\ethernut\nut\app\playmp3\playmp3.c
L26:
	.blkb 10
	.area idata
	.byte 'E,'r,'r,'o,'r,32,37,'d,10,0
	.area data(ram, con, rel)
	.dbfile C:\proj\src\ethernut\nut\app\playmp3\playmp3.c
L23:
	.blkb 10
	.area idata
	.byte 'P,'l,'a,'y,32,37,'s,58,32,0
	.area data(ram, con, rel)
	.dbfile C:\proj\src\ethernut\nut\app\playmp3\playmp3.c
L21:
	.blkb 17
	.area idata
	.byte 'U,'R,'O,'M,58,'s,'o,'u,'n,'d,52,'a,46,'m,'p,51
	.byte 0
	.area data(ram, con, rel)
	.dbfile C:\proj\src\ethernut\nut\app\playmp3\playmp3.c
L20:
	.blkb 17
	.area idata
	.byte 'U,'R,'O,'M,58,'s,'o,'u,'n,'d,51,'a,46,'m,'p,51
	.byte 0
	.area data(ram, con, rel)
	.dbfile C:\proj\src\ethernut\nut\app\playmp3\playmp3.c
L19:
	.blkb 17
	.area idata
	.byte 'U,'R,'O,'M,58,'s,'o,'u,'n,'d,50,'a,46,'m,'p,51
	.byte 0
	.area data(ram, con, rel)
	.dbfile C:\proj\src\ethernut\nut\app\playmp3\playmp3.c
L18:
	.blkb 17
	.area idata
	.byte 'U,'R,'O,'M,58,'s,'o,'u,'n,'d,49,'a,46,'m,'p,51
	.byte 0
	.area data(ram, con, rel)
	.dbfile C:\proj\src\ethernut\nut\app\playmp3\playmp3.c
L13:
	.blkb 22
	.area idata
	.byte 'V,'s,'P,'l,'a,'y,'e,'r,58,32,'F,'a,'t,'a,'l,32
	.byte 'e,'r,'r,'o,'r,0
	.area data(ram, con, rel)
	.dbfile C:\proj\src\ethernut\nut\app\playmp3\playmp3.c
L9:
	.blkb 27
	.area idata
	.byte 'N,'u,'t,'S,'e,'g,'B,'u,'f,'I,'n,'i,'t,58,32,'F
	.byte 'a,'t,'a,'l,32,'e,'r,'r,'o,'r,0
	.area data(ram, con, rel)
	.dbfile C:\proj\src\ethernut\nut\app\playmp3\playmp3.c
L6:
	.blkb 31
	.area idata
	.byte 10,10,'P,'l,'a,'y,32,'M,'P,51,32,'f,'i,'l,'e,'s
	.byte 32,'o,'n,32,'N,'u,'t,47,'O,'S,32,37,'s,10,0
	.area data(ram, con, rel)
	.dbfile C:\proj\src\ethernut\nut\app\playmp3\playmp3.c
L3:
	.blkb 2
	.area idata
	.byte 'w,0
	.area data(ram, con, rel)
	.dbfile C:\proj\src\ethernut\nut\app\playmp3\playmp3.c
L2:
	.blkb 6
	.area idata
	.byte 'u,'a,'r,'t,48,0
	.area data(ram, con, rel)
	.dbfile C:\proj\src\ethernut\nut\app\playmp3\playmp3.c
